geos::operation::valid::ConsistentAreaTester Class Reference

Checks that a geomgraph::GeometryGraph representing an area (a geom::Polygon or geom::MultiPolygon) has consistent semantics for area geometries. This check is required for any reasonable polygonal model (including the OGC-SFS model, as well as models which allow ring self-intersection at single points). More...

`#include <ConsistentAreaTester.h>`

## Public Member Functions

| ConsistentAreaTester (geomgraph::GeometryGraph *newGeomGraph)
geom::Coordinate & | getInvalidPoint ()
bool | isNodeConsistentArea ()
| Check all nodes to see if their labels are consistent with area topology.
bool | hasDuplicateRings ()

## Detailed Description

Checks that a geomgraph::GeometryGraph representing an area (a geom::Polygon or geom::MultiPolygon) has consistent semantics for area geometries. This check is required for any reasonable polygonal model (including the OGC-SFS model, as well as models which allow ring self-intersection at single points).

Checks include:

- test for rings which properly intersect (but not for ring self-intersection, or intersections at vertices)
- test for consistent labelling at all node points (this detects vertex intersections with invalid topology, i.e. where the exterior side of an edge lies in the interior of the area)
- test for duplicate rings

If an inconsistency is found the location of the problem is recorded and is available to the caller.

## Constructor & Destructor Documentation

## ConsistentAreaTester()

geos::operation::valid::ConsistentAreaTester::ConsistentAreaTester | ( | geomgraph::GeometryGraph * | newGeomGraph | ) |

Creates a new tester for consistent areas.

Parameters

  newGeomGraph | the topology graph of the area geometry. Caller keeps responsibility for its deletion

References ConsistentAreaTester().

Referenced by ConsistentAreaTester().

## Member Function Documentation

## getInvalidPoint()

geom::Coordinate & geos::operation::valid::ConsistentAreaTester::getInvalidPoint | ( |  | ) |

Returns
  the intersection point, or `null` if none was found

## hasDuplicateRings()

bool geos::operation::valid::ConsistentAreaTester::hasDuplicateRings | ( |  | ) |

Checks for two duplicate rings in an area. Duplicate rings are rings that are topologically equal (that is, which have the same sequence of points up to point order). If the area is topologically consistent (determined by calling the `isNodeConsistentArea`, duplicate rings can be found by checking for EdgeBundles which contain more than one geomgraph::EdgeEnd. (This is because topologically consistent areas cannot have two rings sharing the same line segment, unless the rings are equal). The start point of one of the equal rings will be placed in invalidPoint.

Returns
  true if this area Geometry is topologically consistent but has two duplicate rings

## isNodeConsistentArea()

bool geos::operation::valid::ConsistentAreaTester::isNodeConsistentArea | ( |  | ) |

Check all nodes to see if their labels are consistent with area topology.

Returns
  `true` if this area has a consistent node labelling

The documentation for this class was generated from the following file:

- ConsistentAreaTester.h